import { CodeGen } from '@volar/code-gen';
import * as SourceMaps from '@volar/source-map';
import type * as templateGen from '../generators/template';
import type { ScriptRanges } from '../parsers/scriptRanges';
import type { ScriptSetupRanges } from '../parsers/scriptSetupRanges';
import type { TeleportMappingData, EmbeddedFileMappingData } from '../types';
export declare function getSlotsPropertyName(vueVersion: number): "$scopedSlots" | "$slots";
export declare function getVueLibraryName(vueVersion: number): "@vue/runtime-dom" | "vue";
export declare function generate(lsType: 'template' | 'script', fileName: string, script: undefined | {
    src?: string;
    content: string;
}, scriptSetup: undefined | {
    content: string;
}, scriptRanges: ScriptRanges | undefined, scriptSetupRanges: ScriptSetupRanges | undefined, getHtmlGen: () => ReturnType<typeof templateGen['generate']> | undefined, getStyleBindTexts: () => string[], shimComponentOptions: 'defineComponent' | 'Vue.extend' | false, downgradePropsAndEmitsToSetupReturnOnScriptSetup: boolean, vueVersion: number): {
    codeGen: CodeGen<EmbeddedFileMappingData>;
    teleports: SourceMaps.Mapping<TeleportMappingData>[];
};
export declare function genConstructorOverloads(name?: string, nums?: number): string;
